import { defineComponent as z, useId as I, ref as i, watch as L, createElementBlock as U, openBlock as k, unref as r, createElementVNode as t, createVNode as u, normalizeStyle as A, normalizeClass as M, createBlock as $, createCommentVNode as H, withCtx as N, toDisplayString as b } from "vue";
import { ScalarButton as T, ScalarIcon as D } from "@scalar/components";
import { REQUEST_METHODS as O } from "@scalar/oas-utils/helpers";
import P from "../CodeInput/CodeInput.vue.js";
import K from "../HttpMethod/HttpMethod.vue.js";
import Q from "./AddressBarHistory.vue.js";
import W from "../Server/ServerDropdown.vue.js";
import { useWorkspace as j } from "../../store/store.js";
import { useLayout as F } from "../../hooks/useLayout.js";
const G = ["id"], J = { class: "m-auto flex flex-row items-center" }, X = { class: "address-bar-bg-states text-xxs p-0.75 group relative order-last flex w-full max-w-[calc(100dvw-24px)] flex-1 flex-row items-stretch rounded-lg lg:order-none lg:min-w-[580px] lg:max-w-[580px] xl:min-w-[720px] xl:max-w-[720px]" }, Y = { class: "pointer-events-none absolute left-0 top-0 block h-full w-full overflow-hidden rounded-lg border" }, Z = { class: "z-context-plus flex gap-1" }, _ = { class: "scroll-timeline-x scroll-timeline-x-hidden z-context-plus relative flex w-full bg-blend-normal" }, ee = {
  "aria-hidden": "true",
  class: "inline-flex items-center gap-1"
}, oe = { class: "sr-only" }, ce = /* @__PURE__ */ z({
  __name: "AddressBar",
  props: {
    collection: {},
    operation: {},
    server: {},
    environment: {},
    envVariables: {},
    workspace: {}
  },
  emits: ["importCurl"],
  setup(n) {
    const m = I(), { requestMutators: p, events: c } = j(), { layout: v } = F(), h = i(null), x = i(null), B = (e) => {
      n.operation.path !== e && p.edit(n.operation.uid, "path", e);
    };
    L(
      () => n.operation.path,
      (e) => {
        e && B(e);
      }
    );
    const l = i(100), w = i(0), a = i(!1), s = i();
    function C() {
      a.value ? l.value -= (l.value - 15) / 60 : l.value -= w.value / 20, l.value <= 0 && (clearInterval(s.value), s.value = void 0, l.value = 100, a.value = !1);
    }
    function y() {
      s.value || (a.value = !0, s.value = setInterval(C, 20));
    }
    function R() {
      w.value = l.value, a.value = !1;
    }
    function q() {
      clearInterval(s.value), s.value = void 0, l.value = 100, a.value = !1;
    }
    c.requestStatus.on((e) => {
      e === "start" && y(), e === "stop" && R(), e === "abort" && q();
    }), c.focusAddressBar.on(() => {
      var e, o, d;
      v === "modal" ? (o = (e = x.value) == null ? void 0 : e.$el) == null || o.focus() : (d = h.value) == null || d.focus();
    });
    function S(e) {
      p.edit(n.operation.uid, "method", e);
    }
    function E() {
      const { method: e } = n.operation;
      return O[e].backgroundColor;
    }
    function g() {
      a.value || (a.value = !0, c.executeRequest.emit({ requestUid: n.operation.uid }));
    }
    c.hotKeys.on((e) => {
      var o;
      e != null && e.focusAddressBar && ((o = h.value) == null || o.focus()), e != null && e.executeRequest && g();
    });
    function V(e) {
      p.edit(n.operation.uid, "path", e);
    }
    return (e, o) => {
      var d;
      return k(), U("div", {
        id: r(m),
        class: "scalar-address-bar order-last h-[--scalar-address-bar-height] w-full [--scalar-address-bar-height:32px] lg:order-none lg:w-auto"
      }, [
        t("div", J, [
          t("div", X, [
            t("div", Y, [
              t("div", {
                class: M(["bg-mix-transparent bg-mix-amount-90 absolute left-0 top-0 z-[1002] h-full w-full", E()]),
                style: A({ transform: `translate3d(-${l.value}%,0,0)` })
              }, null, 6)
            ]),
            t("div", Z, [
              u(K, {
                isEditable: r(v) !== "modal",
                isSquare: "",
                method: e.operation.method,
                teleport: "",
                onChange: S
              }, null, 8, ["isEditable", "method"])
            ]),
            t("div", _, [
              e.collection.servers.length ? (k(), $(r(W), {
                key: 0,
                collection: e.collection,
                layout: "client",
                operation: e.operation,
                server: e.server,
                target: r(m)
              }, null, 8, ["collection", "operation", "server", "target"])) : H("", !0),
              o[1] || (o[1] = t("div", { class: "fade-left" }, null, -1)),
              u(P, {
                ref_key: "addressBarRef",
                ref: h,
                "aria-label": "Path",
                class: "min-w-fit outline-none",
                disableCloseBrackets: "",
                disabled: r(v) === "modal",
                disableEnter: "",
                disableTabIndent: "",
                emitOnBlur: !1,
                envVariables: e.envVariables,
                environment: e.environment,
                importCurl: "",
                modelValue: e.operation.path,
                placeholder: (d = e.server) != null && d.uid && e.collection.servers.includes(e.server.uid) ? "" : "Enter a URL or cURL command",
                server: "",
                workspace: e.workspace,
                onCurl: o[0] || (o[0] = (f) => e.$emit("importCurl", f)),
                onSubmit: g,
                "onUpdate:modelValue": V
              }, null, 8, ["disabled", "envVariables", "environment", "modelValue", "placeholder", "workspace"]),
              o[2] || (o[2] = t("div", { class: "fade-right" }, null, -1))
            ]),
            u(Q, {
              operation: e.operation,
              target: r(m)
            }, null, 8, ["operation", "target"]),
            u(r(T), {
              ref_key: "sendButtonRef",
              ref: x,
              class: "z-context-plus relative h-auto shrink-0 overflow-hidden py-1 pl-2 pr-2.5 font-bold",
              disabled: a.value,
              onClick: g
            }, {
              default: N(() => {
                var f;
                return [
                  t("span", ee, [
                    u(r(D), {
                      class: "relative shrink-0 fill-current",
                      icon: "Play",
                      size: "xs"
                    }),
                    o[3] || (o[3] = t("span", { class: "text-xxs hidden lg:flex" }, "Send", -1))
                  ]),
                  t("span", oe, " Send " + b(e.operation.method) + " request to " + b(((f = e.server) == null ? void 0 : f.url) ?? "") + b(e.operation.path), 1)
                ];
              }),
              _: 1
            }, 8, ["disabled"])
          ])
        ])
      ], 8, G);
    };
  }
});
export {
  ce as default
};
