import { ERRORS as P, normalizeError as U } from "../errors.js";
import { normalizeHeaders as G } from "../normalize-headers.js";
import { createFetchBody as J } from "./create-fetch-body.js";
import { createFetchHeaders as N } from "./create-fetch-headers.js";
import { createFetchQueryParams as Z } from "./create-fetch-query-params.js";
import { decodeBuffer as $ } from "./decode-buffer.js";
import { setRequestCookies as M, getCookieHeader as ee } from "./set-request-cookies.js";
import { replaceTemplateVariables as d } from "../string-template.js";
import { isElectron as oe } from "../electron.js";
import { isDefined as te, mergeUrls as re, shouldUseProxy as q, redirectToProxy as se, httpStatusCodes as ne } from "@scalar/oas-utils/helpers";
import { buildRequestSecurity as ae } from "./build-request-security.js";
const Re = ({
  environment: D,
  example: a,
  globalCookies: E,
  proxyUrl: l,
  request: i,
  securitySchemes: L,
  selectedSecuritySchemeUids: z = [],
  server: c,
  status: o,
  pluginManager: u
}) => {
  try {
    const t = D ?? {}, S = new AbortController(), w = a.parameters.path.reduce((e, s) => (s.enabled && (e[s.key] = d(s.value, t)), e), {}), B = d((c == null ? void 0 : c.url) ?? "", t), f = d(d(i.path, t), w);
    let n = B || f;
    if (!n)
      throw P.URL_EMPTY;
    Object.entries((c == null ? void 0 : c.variables) ?? {}).forEach(([e, s]) => {
      n = d(n, {
        [e]: w[e] || s.default
      });
    });
    const F = Z(a, t, i), _ = N(a, t), { body: O } = J(i.method, a, t), { cookieParams: W } = M({
      example: a,
      env: t,
      globalCookies: E,
      serverUrl: n,
      proxyUrl: l
    }), x = z.flat().map((e) => L[e]).filter(te), b = ae(x, t), p = { ...Object.entries(b.headers).reduce(
      (e, [s, y]) => (e[s.toLowerCase()] = y, e),
      {}
    ), ..._ }, j = [...W, ...b.cookies], A = new URLSearchParams([...F, ...b.urlParams]);
    n = re(n, f, A);
    const k = d(ee(j, p.Cookie), t);
    k && (oe() || q(l, n) ? (console.warn(
      "We’re using a `X-Scalar-Cookie` custom header to the request. The proxy will forward this as a `Cookie` header. We do this to avoid the browser omitting the `Cookie` header for cross-origin requests for security reasons."
    ), p["X-Scalar-Cookie"] = k) : (console.warn(
      `We’re trying to add a Cookie header, but browsers often omit them for cross-origin requests for various security reasons. If it’s not working, that’s probably why. Here are the requirements for it to work:

          - The browser URL must be on the same domain as the server URL.
          - The connection must be made over HTTPS.
          `
    ), p.Cookie = k));
    const I = se(l, n), R = new Request(I, {
      method: i.method.toUpperCase(),
      body: O ?? null,
      headers: p
    });
    return [
      null,
      {
        request: R,
        sendRequest: async () => {
          var s, y, C;
          o == null || o.emit("start"), u && u.executeHook("onBeforeRequest");
          const e = Date.now();
          try {
            const r = await fetch(R, {
              signal: S.signal
            }), Q = (s = r.headers.get("content-type")) == null ? void 0 : s.startsWith("text/event-stream");
            o == null || o.emit("stop");
            const V = Date.now() - e, X = r.clone(), T = G(r.headers, q(l, n)), v = r.headers.get("content-type") ?? "text/plain;charset=UTF-8", g = await X.arrayBuffer(), K = $(g, v), m = r.clone(), Y = m.statusText || ((y = ne[m.status]) == null ? void 0 : y.name) || "", h = new Response(m.body, {
              status: m.status,
              statusText: Y,
              headers: m.headers
            });
            u && u.executeHook("onResponseReceived", { response: h, operation: i });
            const H = "getSetCookie" in h.headers && typeof h.headers.getSetCookie == "function" ? h.headers.getSetCookie() : [];
            return Q && r.body ? [
              null,
              {
                timestamp: Date.now(),
                request: a,
                response: {
                  ...h,
                  headers: T,
                  cookieHeaderKeys: H,
                  reader: (C = r.body) == null ? void 0 : C.getReader(),
                  duration: V,
                  method: i.method,
                  path: f
                }
              }
            ] : [
              null,
              {
                timestamp: Date.now(),
                request: a,
                response: {
                  ...r,
                  headers: T,
                  cookieHeaderKeys: H,
                  data: K,
                  size: g.byteLength,
                  duration: Date.now() - e,
                  method: i.method,
                  status: r.status,
                  path: f
                }
              }
            ];
          } catch (r) {
            return o == null || o.emit("abort"), [U(r, P.REQUEST_FAILED), null];
          }
        },
        controller: S
      }
    ];
  } catch (t) {
    return console.error(t), o == null || o.emit("abort"), [U(t), null];
  }
};
export {
  Re as createRequestOperation
};
