import { defineComponent as U, computed as v, useId as g, ref as D, watch as M, createBlock as p, openBlock as n, withCtx as c, createElementVNode as y, withDirectives as s, createCommentVNode as h, createElementBlock as f, createVNode as i, unref as r, vShow as m, Fragment as K, renderList as L, resolveDynamicComponent as Q, toDisplayString as $ } from "vue";
import { ScalarErrorBoundary as P } from "@scalar/components";
import { canMethodHaveBody as k, isDefined as F, REGEX as S } from "@scalar/oas-utils/helpers";
import j from "../../../components/SectionFilter.vue.js";
import T from "../../../components/ViewLayout/ViewLayoutSection.vue.js";
import { matchesDomain as W } from "../../../libs/send-request/set-request-cookies.js";
import z from "./RequestBody.vue.js";
import b from "./RequestParams.vue.js";
import G from "./RequestPathParams.vue.js";
import X from "./RequestAuth/RequestAuth.vue.js";
import J from "./RequestCodeExample.vue.js";
import { usePluginManager as Y } from "../../../plugins/hooks/usePluginManager.js";
import { useWorkspace as Z } from "../../../store/store.js";
import { useLayout as x } from "../../../hooks/useLayout.js";
const _ = { class: "group pointer-events-none flex flex-1 items-center gap-1 lg:pr-24" }, ee = ["for"], ae = ["id", "placeholder", "value"], oe = {
  key: 2,
  class: "text-c-1 flex h-8 items-center"
}, le = ["id", "role"], be = /* @__PURE__ */ U({
  __name: "RequestSection",
  props: {
    collection: {},
    environment: {},
    envVariables: {},
    example: {},
    invalidParams: {},
    operation: {},
    selectedSecuritySchemeUids: {},
    server: {},
    workspace: {}
  },
  setup(o) {
    const C = [
      "Auth",
      "Variables",
      "Cookies",
      "Headers",
      "Query",
      "Body",
      "Scripts"
    ], { requestMutators: V, cookies: B, securitySchemes: R } = Z(), { layout: d } = x(), w = v(() => {
      const e = /* @__PURE__ */ new Set(["All", ...C]);
      return o.example.parameters.path.length || e.delete("Variables"), k(o.operation.method ?? "get") || e.delete("Body"), A.value && e.delete("Auth"), [...e];
    }), t = v(
      () => Object.fromEntries(
        w.value.map((e) => [e, g()])
      )
    ), A = v(
      () => {
        var e;
        return d === "modal" && ((e = o.operation.security) == null ? void 0 : e.length) === 0;
      }
    ), a = D("All");
    M(
      () => o.operation,
      (e) => {
        a.value === "Body" && e && !k(e.method) && (a.value = "All");
      }
    );
    const O = (e) => {
      const l = e.target;
      V.edit(o.operation.uid, "summary", l.value);
    }, E = v(
      () => (o.workspace.cookies ?? []).map((e) => B[e]).filter(F).filter((e) => e.name).filter(
        (e) => {
          var l;
          return W(((l = o.server) == null ? void 0 : l.url) || o.operation.path, e.domain);
        }
      ).map((e) => ({
        key: e.name,
        value: e.value,
        route: {
          name: "cookies",
          params: {
            cookies: e.uid
          }
        },
        enabled: !0
      }))
    ), H = () => o.operation.summary ? o.operation.summary : o.operation.path.replace(S.PROTOCOL, "") ? o.operation.path.replace(S.PROTOCOL, "") : "Request Name", q = g(), N = Y().getViewComponents("request.section"), I = (e, l) => V.edit(o.operation.uid, e, l);
    return (e, l) => (n(), p(T, {
      "aria-label": `Request: ${e.operation.summary}`
    }, {
      title: c(() => [
        y("div", _, [
          r(d) !== "modal" ? (n(), f("label", {
            key: 0,
            class: "pointer-events-auto absolute left-0 top-0 h-full w-full cursor-text opacity-0",
            for: r(q)
          }, null, 8, ee)) : h("", !0),
          r(d) !== "modal" ? (n(), f("input", {
            key: 1,
            id: r(q),
            class: "text-c-1 group-hover-input pl-1.25 md:-ml-1.25 pointer-events-auto relative z-10 -ml-0.5 h-8 w-full rounded has-[:focus-visible]:outline",
            placeholder: H(),
            value: e.operation.summary,
            onInput: O
          }, null, 40, ae)) : (n(), f("span", oe, $(e.operation.summary), 1))
        ]),
        i(j, {
          modelValue: a.value,
          "onUpdate:modelValue": l[0] || (l[0] = (u) => a.value = u),
          filterIds: t.value,
          filters: w.value
        }, null, 8, ["modelValue", "filterIds", "filters"])
      ]),
      default: c(() => [
        y("div", {
          id: t.value.All,
          class: "request-section-content custom-scroll relative flex flex-1 flex-col",
          role: a.value === "All" ? "tabpanel" : "none"
        }, [
          e.collection && e.workspace && (r(d) !== "modal" || Object.keys(r(R) ?? {}).length) ? s((n(), p(X, {
            key: 0,
            id: t.value.Auth,
            class: "request-section-content-auth",
            collection: e.collection,
            envVariables: e.envVariables,
            environment: e.environment,
            layout: "client",
            operation: e.operation,
            role: a.value === "All" ? "none" : "tabpanel",
            selectedSecuritySchemeUids: e.selectedSecuritySchemeUids,
            server: e.server,
            title: "Authentication",
            workspace: e.workspace
          }, null, 8, ["id", "collection", "envVariables", "environment", "operation", "role", "selectedSecuritySchemeUids", "server", "workspace"])), [
            [
              m,
              !A.value && (a.value === "All" || a.value === "Auth")
            ]
          ]) : h("", !0),
          s(i(G, {
            id: t.value.Variables,
            class: "request-section-content-path-params",
            envVariables: e.envVariables,
            environment: e.environment,
            example: e.example,
            invalidParams: e.invalidParams,
            operation: e.operation,
            paramKey: "path",
            role: a.value === "All" ? "none" : "tabpanel",
            title: "Variables",
            workspace: e.workspace
          }, null, 8, ["id", "envVariables", "environment", "example", "invalidParams", "operation", "role", "workspace"]), [
            [
              m,
              (a.value === "All" || a.value === "Variables") && e.example.parameters.path.length
            ]
          ]),
          s(i(b, {
            id: t.value.Cookies,
            class: "request-section-content-cookies",
            envVariables: e.envVariables,
            environment: e.environment,
            example: e.example,
            invalidParams: e.invalidParams,
            label: "Cookie",
            operation: e.operation,
            paramKey: "cookies",
            readOnlyEntries: E.value,
            role: a.value === "All" ? "none" : "tabpanel",
            title: "Cookies",
            workspace: e.workspace
          }, null, 8, ["id", "envVariables", "environment", "example", "invalidParams", "operation", "readOnlyEntries", "role", "workspace"]), [
            [m, a.value === "All" || a.value === "Cookies"]
          ]),
          s(i(b, {
            id: t.value.Headers,
            class: "request-section-content-headers",
            envVariables: e.envVariables,
            environment: e.environment,
            example: e.example,
            invalidParams: e.invalidParams,
            label: "Header",
            operation: e.operation,
            paramKey: "headers",
            role: a.value === "All" ? "none" : "tabpanel",
            title: "Headers",
            workspace: e.workspace
          }, null, 8, ["id", "envVariables", "environment", "example", "invalidParams", "operation", "role", "workspace"]), [
            [m, a.value === "All" || a.value === "Headers"]
          ]),
          s(i(b, {
            id: t.value.Query,
            class: "request-section-content-query",
            envVariables: e.envVariables,
            environment: e.environment,
            example: e.example,
            invalidParams: e.invalidParams,
            label: "Parameter",
            operation: e.operation,
            paramKey: "query",
            role: a.value === "All" ? "none" : "tabpanel",
            title: "Query Parameters",
            workspace: e.workspace
          }, null, 8, ["id", "envVariables", "environment", "example", "invalidParams", "operation", "role", "workspace"]), [
            [m, a.value === "All" || a.value === "Query"]
          ]),
          e.operation.method && (a.value === "All" || a.value === "Body") && r(k)(e.operation.method) ? (n(), p(z, {
            key: 1,
            id: t.value.Body,
            class: "request-section-content-body",
            envVariables: e.envVariables,
            environment: e.environment,
            example: e.example,
            operation: e.operation,
            role: a.value === "All" ? "none" : "tabpanel",
            title: "Body",
            workspace: e.workspace
          }, null, 8, ["id", "envVariables", "environment", "example", "operation", "role", "workspace"])) : h("", !0),
          (n(!0), f(K, null, L(r(N), (u) => (n(), p(r(P), {
            key: u.component
          }, {
            default: c(() => [
              s((n(), p(Q(u.component), {
                "onUpdate:operation": I,
                operation: e.operation
              }, null, 40, ["operation"])), [
                [m, a.value === "All" || a.value === u.title]
              ])
            ]),
            _: 2
          }, 1024))), 128)),
          l[1] || (l[1] = y("div", { class: "flex flex-grow" }, null, -1)),
          i(r(P), null, {
            default: c(() => [
              i(J, {
                class: "request-section-content-code-example -mt-1/2 border-t",
                collection: e.collection,
                example: e.example,
                operation: e.operation,
                server: e.server,
                workspace: e.workspace,
                environment: e.envVariables
              }, null, 8, ["collection", "example", "operation", "server", "workspace", "environment"])
            ]),
            _: 1
          })
        ], 8, le)
      ]),
      _: 1
    }, 8, ["aria-label"]));
  }
});
export {
  be as default
};
